#include <windows.h>

#define EXPORT __declspec(dllexport)

#include "../include/dwterm.h"



DWTRMF *dwt;

DWTRMD_Canvas *cvl, *cvr;

#define IPT_BkBrush    0                       
#define IPT_Brush      1
#define IPT_Pen        2
#define IPT_Font       3
#define IPT_Num        IPT_Font+1



//***********************************************************************
//              Drawing variable delpth objects
//***********************************************************************


DWTRMD_Area area;

int z=0;

void draw (void)
   {
   dwt->PushArea(&area);
      dwt->MoveArea(&area, z, 0, 0);
      char Buffer[100];
      dwt->PushArea(&area);
         area.rc.right=area.rc.left+200;
         DrawText(cvl->hDC, "move z: ", -1, &(area.rc),
                                             DT_CENTER|DT_SINGLELINE|DT_VCENTER);
         dwt->MoveArea(&area, 0, 200, 0);
         InflateRect(&(area.rc), -25, -25);
         Rectangle(cvl->hDC, area.rc.left, area.rc.top,
                             area.rc.right, area.rc.bottom);
      dwt->PopArea(&area);
      dwt->ShowArea(&area, -1);
   dwt->PopArea(&area);
   }



//***********************************************************************
//                        Load & Unload
//***********************************************************************


EXPORT char *dwTermH_Load (char *CmdLine, char **Title, DWTRMF *dwtf)
   {

   dwt=dwtf;

   // Create and register the canvas.
   cvl=dwt->CreateCanvas(400, 300);
   dwt->RegisterCanvas(cvl, FALSE);
   dwt->FitDisplay();

   // Create and select painting tools.
   dwt->NewPaintingBox(IPT_Num);
   dwt->NewBrush(IPT_BkBrush, CreateSolidBrush(0x000000));
   dwt->NewBrush(IPT_Brush, CreateSolidBrush(0xff0000));
   dwt->NewPen(IPT_Pen, CreatePen(PS_SOLID, 5, 0x00ffff));
   dwt->NewFont(IPT_Font, CreateFont(25, 15, 0, 0, 600, FALSE, FALSE, FALSE,
                               DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
                               DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE,
                               "arial"));
   dwt->SelectBrush(IPT_Brush);
   dwt->SelectPen(IPT_Pen);
   dwt->SelectFont(IPT_Font);

   // Register the right canvas to enable anaglyph.
   cvr=dwt->CreateCanvas(400, 250);
   dwt->AnaglyphCanvas(cvr);

   // Erase.
   dwt->CopyArea(&area, NULL);
   dwt->ShowArea(&area, IPT_BkBrush);

   // Drawing the zero-depth objects
   area.rc.top=250;
   area.rc.bottom=300;
   dwt->SelectFont(IPT_Font);
   SetTextColor(cvl->hDC, 0xffffff);
   SetBkMode(cvl->hDC, TRANSPARENT);
   DrawText(cvl->hDC, "Enjoy anaglyphs above", -1, &(area.rc),
                                     DT_CENTER|DT_SINGLELINE|DT_VCENTER);
   dwt->ShowArea(&area, -1);

   // Drawing the fixed-depth objects
   area.rc.top=125;
   area.rc.bottom=250;
   dwt->NewAreaStack(10);
   dwt->PushArea(&area);
   area.rc.bottom=175;
   //
   dwt->PushArea(&area);
      dwt->MoveArea(&area, -2, 0, 0);
      dwt->PushArea(&area);
         area.rc.right=area.rc.left+200;
         DrawText(cvl->hDC, "Above the screen: ", -1, &(area.rc), DT_CENTER|DT_WORDBREAK);
         dwt->MoveArea(&area, 0, 200, 0);
         InflateRect(&(area.rc), -25, -5);
         Pie(cvl->hDC, area.rc.left, area.rc.top,
                       area.rc.right, area.rc.bottom,
                       area.rc.left, area.rc.top,
                       area.rc.left+100, area.rc.top);
      dwt->PopArea(&area);
      dwt->ShowArea(&area, -1);
   dwt->PopArea(&area);
   //
   dwt->MoveArea(&area, 0, 0, 50);
   area.rc.bottom+=25;
   //
   dwt->PushArea(&area);
      dwt->MoveArea(&area, 2, 0, 0);
      dwt->PushArea(&area);
         area.rc.right=area.rc.left+200;
         DrawText(cvl->hDC, "Below the screen: ", -1, &(area.rc), DT_CENTER|DT_WORDBREAK);
         dwt->MoveArea(&area, 0, 200, 0);
         InflateRect(&(area.rc), -25, -25);
         Ellipse(cvl->hDC, area.rc.left, area.rc.top,
                       area.rc.right, area.rc.bottom);
      dwt->PopArea(&area);
      dwt->ShowArea(&area, -1);
   dwt->PopArea(&area);

   // Drawing the variable depth objects
   dwt->PopArea(&area);
   dwt->MoveArea(&area, 0, 0, -125);
   draw();

   return NULL;

   }


EXPORT char *dwTermH_Unload (void)
   {
   dwt->DeleteCanvas(cvl);
   dwt->DeleteCanvas(cvr);
   return NULL;
   }



//***********************************************************************
//                           Command
//***********************************************************************


#define RetParam { \
   sprintf(Result, "z = %d", z); \
   return Result; \
}


#define RetErrorWrongNumber { \
   return "Error! Wrong number of tokens."; \
}


#define RetErrorWrongToken { \
   return "Error! A wrong token."; \
}


char Result[256]; // Buffer for displaying a message on the status bar.


EXPORT char *dwTermH_Command (int nToken, char **token)
   {

   int i;
   if(nToken<=0) return NULL;

   if(!strcmp(token[0], "move"))
      {
      if(nToken==1) RetParam //Just show z on the status bar.
      if(nToken==2)
         {
         dwt->ShowArea(&area, IPT_BkBrush);
         z=atoi(token[1]);
         draw();
         RetParam;
         }
      RetErrorWrongNumber
      }

   RetErrorWrongToken

   }

